/**
TetrisCommand is a remake of the eponym game from Atari ST / Amiga
The program is developped under an event that took place on internet with the goal to make a game in a weekend
Copyright (C) 2014  Alexandre "LittleWhite" LAURENT

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://www.developpez.net/forums/d1465457/applications/developpement-2d-3d-jeux/projets/we-jv4-mix-weekend-tetriscommand/
e-mail: lw.demoscene@gmail.com
**/

#ifndef BOMB_HPP
#define BOMB_HPP

#include "NEngine/Types/Vec2.h"

namespace NE
{
    class Sprite;
    class Renderer;
}
class AnimatedSprite;

class Bomb
{
    enum State
    {
        LIVE,
        EXPLODING,
        DEAD
    };

private:
    Vec2<float> m_position;
    UVec2 m_startingPosition;
    UVec2 m_destination;

    AnimatedSprite* m_pBombSprite;
    AnimatedSprite* m_pExplosionSprite;

    State m_state;
    unsigned m_explosionTime;

    Bomb(const Bomb& bomb);

public:
    Bomb(const UVec2& startingPosition, const UVec2 destination,
         const NE::Sprite* pBombSprite, const NE::Sprite* pExplosionSprite);
    ~Bomb();

    bool render(NE::Renderer& renderer, const unsigned int time);
    void update(float speed);

    bool isExplosing() { return m_state == EXPLODING; }
    bool isExploded() { return m_state == DEAD; }

    const UVec2& explosionPosition()const { return m_destination; }
};

#endif
