/**
TetrisCommand is a remake of the eponym game from Atari ST / Amiga
The program is developped under an event that took place on internet with the goal to make a game in a weekend
Copyright (C) 2014  Alexandre "LittleWhite" LAURENT

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://www.developpez.net/forums/d1465457/applications/developpement-2d-3d-jeux/projets/we-jv4-mix-weekend-tetriscommand/
e-mail: lw.demoscene@gmail.com
**/

#ifndef BOARDGAME_HPP
#define BOARDGAME_HPP

#include "NEngine/Types/Size2.h"

#include "Game/GameInfo.hpp"

#include <string>
#include <sstream>

namespace NE
{
    class Sprite;
    class Renderer;
}

class Font;

class BoardGame
{
private:
    const NE::Sprite* m_pBorderSprite;
    const NE::Sprite* m_pLineSprite;
    const NE::Sprite* m_pCitySprite;

    const NE::Sprite* m_pScoreSprite;
    const NE::Sprite* m_pLevelSprite;
    const NE::Sprite* m_pBlocksSprite;

    const NE::Sprite* m_pBombsSprite;
    const NE::Sprite* m_pSpeedSprite;
    const NE::Sprite* m_pTimeSprite;
    const NE::Sprite* m_pBonusSprite;

    bool m_bonusTime;

    Font* m_pFont;

    template <typename T>
    std::string toString(T value)
    {
        std::ostringstream oss;

        oss << value;

        return oss.str();
    }

public:
    BoardGame(const NE::Sprite* pBorderSprite, const NE::Sprite* pLineSprite, const NE::Sprite *pCitySprite,
              const NE::Sprite* pScoreSprite,const NE::Sprite* pLevelSprite,const NE::Sprite* pBlocksSprite,
              const NE::Sprite* pBombsSprite,const NE::Sprite* pSpeedSprite,const NE::Sprite* pTimeSprite,
              const NE::Sprite* pBonusSprite,
              Font* pFont);
    ~BoardGame() {}

    bool render(const NE::Renderer& renderer, const GameInfo &gi);
    void setBonusTime(const bool bonusTime) { m_bonusTime = bonusTime; }
    bool isBonusTime()const { return m_bonusTime; }

};

#endif
