/**
TetrisCommand is a remake of the eponym game from Atari ST / Amiga
The program is developped under an event that took place on internet with the goal to make a game in a weekend
Copyright (C) 2014  Alexandre "LittleWhite" LAURENT

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://www.developpez.net/forums/d1465457/applications/developpement-2d-3d-jeux/projets/we-jv4-mix-weekend-tetriscommand/
e-mail: lw.demoscene@gmail.com
**/

#ifndef CURSOR_HPP
#define CURSOR_HPP

#include "NEngine/Types/Size2.h"

namespace NE
{
    class Sprite;
    class Renderer;
}

class Cursor
{
private:

    const NE::Sprite* m_pCursorSprite;

    IVec2 m_position;

public:
    Cursor(const NE::Sprite* pCursorSprite)
        :m_pCursorSprite(pCursorSprite),m_position(0,0) {}

    bool render(NE::Renderer& renderer);
    void setPosition(const IVec2& newPosition) { m_position = newPosition; }
};

#endif
