#ifndef COMMON_HPP
#define COMMON_HPP

#define WINDOW_WIDTH 800
#define WINDOW_HEIGHT 600

#define PANEL_WIDTH 200
#define PANEL_LEFT_POSX PANEL_WIDTH
#define PANEL_RIGHT_POSX (WINDOW_WIDTH - PANEL_WIDTH)

#define BASE_HEIGHT 75
#define CITY_POSY (WINDOW_HEIGHT - BASE_HEIGHT)
#define BASE_LINE_POSY (WINDOW_HEIGHT - BASE_HEIGHT)

#define GFX_PATH "./data/gfx/"
#define BOARDGAME_BORDER_PATH GFX_PATH "border.png"
#define BOARDGAME_LINE_PATH GFX_PATH "line.png"
#define BOARDGAME_CITY_PATH GFX_PATH "city2-400px.png"

#define SCORE_POSY 100
#define LEVEL_POSY 200
#define BLOCKS_POSY 300

#define BOARDGAME_SCORE_PATH GFX_PATH "ui-score.png"
#define BOARDGAME_LEVEL_PATH GFX_PATH "ui-level.png"
#define BOARDGAME_BLOCKS_PATH GFX_PATH "ui-blocks.png"

#define BOMBS_POSY 150
#define SPEED_POSY 300
#define TIME_POSY 450

#define BOARDGAME_BOMBS_PATH GFX_PATH "ui-bombs.png"
#define BOARDGAME_SPEED_PATH GFX_PATH "ui-speed.png"
#define BOARDGAME_TIME_PATH GFX_PATH "ui-time.png"
#define BOARDGAME_BONUS_PATH GFX_PATH "ui-bonus.bmp"

#define NB_TOTAL_COLORS 8
#define BLOCK_SIZE 8

#define PIECE_PATH "./data/pieces/"

#define PIECE_START_POSX PANEL_LEFT_POSX + 16
#define PIECE_START_POSY -50
#define GAME_AREA ((PANEL_RIGHT_POSX-16) - PANEL_LEFT_POSX)

#define BLOCKS_TILE_PATH GFX_PATH "blocks.png"

#define START_SPAWN_DELAY 3000
#define START_SHOOT_DELAY 600

#define BOMB_PATH GFX_PATH "bomb.png"
#define BOMB_WIDTH 8
#define BOMB_HEIGHT 8
#define BOMB_ANIMATION_STEP_TIME 150

#define EXPLOSION_PATH GFX_PATH "explosion3.bmp"
#define EXPLOSION_WIDTH 64
#define EXPLOSION_HEIGHT 64
#define EXPLOSION_ANIMATION_STEP_TIME 100

#define BLOCK_EXPLOSION_PATH GFX_PATH "explosion-mini.bmp"
#define BLOCK_EXPLOSION_WIDTH 16
#define BLOCK_EXPLOSION_HEIGHT 16
#define BLOCK_EXPLOSION_ANIMATION_STEP_TIME 50

#define CURSOR_PATH GFX_PATH "cursor.bmp"
#define CURSOR_WIDTH 16
#define CURSOR_HEIGHT 16

#define START_FALL_SPEED 0.05f
#define START_BOMB_SPEED 0.1f
#define START_BOMB_NUMBER 3

#define START_BOMB_POSX WINDOW_WIDTH/2
#define START_BOMB_POSY WINDOW_HEIGHT-BASE_HEIGHT

#define BOMB_RADIUS_EFFECT 24

#define FONT_PATH GFX_PATH "font.bmp"
#define FONT_WIDTH 16
#define FONT_HEIGHT 16

#define NEWGAME_PATH GFX_PATH "newgame.png"
#define QUIT_PATH GFX_PATH "quit.png"

#define GAMEOVER_PATH GFX_PATH "gameover.bmp"

#endif
